package arrays;
import java.util.Calendar;
import java.util.GregorianCalendar;

public class Persona {
	
	//-------Attributes------//
	private String nombre,apellido;
	private Calendar fechaDeNacimiento = new GregorianCalendar();
	private int dni;
	private boolean sexoMasculino;
	
	//-------Constraints------//
	public Persona(String nombre, String apellido, String fechaDeNacimiento,int dni, boolean sexoMasculino){
		this.nombre = nombre;
		this.apellido = apellido;
		this.dni = dni;
		this.sexoMasculino = sexoMasculino;
		this.setFecha(fechaDeNacimiento);
	}
	
	//-------Method String to Calendar---------//
	private void setFecha(String fechaDeNacimiento){
		int dia = 0,mes = 0,año = 0, cant = 0, ant = 0;
		for (int x = 0;x < fechaDeNacimiento.length();x++){
			if (fechaDeNacimiento.charAt(x) == '/'){
				switch(cant){
					case 0:
						cant++;
						dia = Integer.parseInt(fechaDeNacimiento.substring(0, x));
						ant = x;
						break;
					case 1:
						cant++;
						mes = (Integer.parseInt(fechaDeNacimiento.substring(ant+1, x)))-1;
						año = Integer.parseInt(fechaDeNacimiento.substring(x+1,x+5));
						break;
				}
			}
		}
		this.fechaDeNacimiento.set(año, mes, dia);
	}
	
	//-------Method toString-------//
	public String toString(){
		return "Nombre: " + nombre + "\n" +
			   "Apellido: " + apellido + "\n" + 
			   "Fecha de nacimiento: " + fechaDeNacimiento.get(Calendar.DATE ) + "/" + ((int)fechaDeNacimiento.get(Calendar.MONTH)+1)+"/"+ fechaDeNacimiento.get(Calendar.YEAR) + "\n" +
			   "Dni: " + dni + "\n" +
			   "Sexo: " + getSexo() + "\n" +
			   "Edad: " + getEdad() + "\n";
	}
	
	//--------Get methods---------//
	public String getSexo(){
		if (this.sexoMasculino){
			return "Masculino";
		}else{
			return "Femenino";
		}
	}
	
	public int getEdad(){
		int dia,mes;
		boolean cumplidos = false;
		Calendar actual = Calendar.getInstance();
		mes = actual.get(Calendar.MONTH) - fechaDeNacimiento.get(Calendar.MONTH);
		dia = actual.get(Calendar.DATE) - fechaDeNacimiento.get(Calendar.DATE);
		if (mes > 0){
			cumplidos = true;
		}else if(mes == 0){
			if (dia>=0){
				cumplidos = true;
			}
		}
		if (cumplidos){
			return actual.get(Calendar.YEAR) - fechaDeNacimiento.get(Calendar.YEAR);
		}else{
			return (actual.get(Calendar.YEAR) - fechaDeNacimiento.get(Calendar.YEAR))-1;
		}
	}
	
}
